# AgreeKeyRequest

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**PrivateKey** | [***SobjectDescriptor**](SobjectDescriptor.md) |  | [default to null]
**PublicKey** | [***SobjectDescriptor**](SobjectDescriptor.md) |  | [default to null]
**Name** | **string** | Name of the agreed-upon key. Key names must be unique within an account. The name is ignored for transient keys and should be the empty string. | [default to null]
**GroupId** | **string** | Group ID (not name) of the security group that this security object should belong to. The user or application creating this security object must be a member of this group. If no group is specified, the default group for the user or application will be used.  | [optional] [default to null]
**KeySize** | **int32** | Key size of the derived key in bits (not bytes). | [default to null]
**KeyType** | [***ObjectType**](ObjectType.md) |  | [default to null]
**Mechanism** | [***AgreeKeyMechanism**](AgreeKeyMechanism.md) |  | [default to null]
**Enabled** | **bool** | Whether the derived key should have cryptographic operations enabled. | [optional] [default to null]
**Description** | **string** | Description for the new key. | [optional] [default to null]
**KeyOps** | [**[]KeyOperations**](KeyOperations.md) | Optional array of key operations to be enabled for this security object. If this property is not provided, the SDKMS server will provide a default set of key operations. Note that if you provide an empty array, all key operations will be disabled.  | [optional] [default to null]
**CustomMetadata** | **map[string]string** | User-defined metadata for this key. Stored as key-value pairs. | [optional] [default to null]
**Transient** | **bool** | If this is true, SDKMS will derive a transient key. | [optional] [default to null]

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


