# \UsersApi

All URIs are relative to *https://apps.smartkey.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**ChangePassword**](UsersApi.md#ChangePassword) | **Post** /sys/v1/users/change_password | Change user password
[**ConfirmEmail**](UsersApi.md#ConfirmEmail) | **Post** /sys/v1/users/{user-id}/confirm_email | Confirms user&#39;s email address
[**CreateUser**](UsersApi.md#CreateUser) | **Post** /sys/v1/users | Create a new user
[**DeleteUser**](UsersApi.md#DeleteUser) | **Delete** /sys/v1/users/{user-id}/account | Removed user&#39;s association with an account
[**DeleteUserAccount**](UsersApi.md#DeleteUserAccount) | **Delete** /sys/v1/users | Completely delete a user profile from system
[**ForgotPassword**](UsersApi.md#ForgotPassword) | **Post** /sys/v1/users/forgot_password | Initiate password reset sequence for a user
[**GetUser**](UsersApi.md#GetUser) | **Get** /sys/v1/users/{user-id} | Get a specific user
[**GetUserAccount**](UsersApi.md#GetUserAccount) | **Get** /sys/v1/users/accounts | Get account information for the user
[**GetUsers**](UsersApi.md#GetUsers) | **Get** /sys/v1/users | Get all users
[**InviteUser**](UsersApi.md#InviteUser) | **Post** /sys/v1/users/invite | Invite a user
[**ProcessInvitations**](UsersApi.md#ProcessInvitations) | **Post** /sys/v1/users/process_invite | Process a user&#39;s pending account invitations
[**ResendConfirmEmail**](UsersApi.md#ResendConfirmEmail) | **Post** /sys/v1/users/{user-id}/resend_confirm_email | Resend email with link to confirm user&#39;s email address
[**ResendInvitation**](UsersApi.md#ResendInvitation) | **Post** /sys/v1/users/{user-id}/resend_invite | Resend invite to the user to join a specific account
[**ResetPassword**](UsersApi.md#ResetPassword) | **Post** /sys/v1/users/{user-id}/reset_password | Reset a user&#39;s password
[**UpdateUser**](UsersApi.md#UpdateUser) | **Patch** /sys/v1/users/{user-id} | Update user
[**ValidatePasswordResetToken**](UsersApi.md#ValidatePasswordResetToken) | **Post** /sys/v1/users/{user-id}/validate_token | Validates password reset token for the user


# **ChangePassword**
> ChangePassword(ctx, body)
Change user password

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for logging, tracing, authentication, etc.
  **body** | [**PasswordChangeRequest**](PasswordChangeRequest.md)| Password change request | 

### Return type

 (empty response body)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ConfirmEmail**
> ConfirmEmailResponse ConfirmEmail(ctx, userId, body)
Confirms user's email address

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for logging, tracing, authentication, etc.
  **userId** | **string**| User Identifier | 
  **body** | [**ConfirmEmailRequest**](ConfirmEmailRequest.md)| Validate user&#39;s email | 

### Return type

[**ConfirmEmailResponse**](ConfirmEmailResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **CreateUser**
> User CreateUser(ctx, body)
Create a new user

Signs up a new user.

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for logging, tracing, authentication, etc.
  **body** | [**SignupRequest**](SignupRequest.md)| Email address of user | 

### Return type

[**User**](User.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **DeleteUser**
> DeleteUser(ctx, userId)
Removed user's association with an account

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for logging, tracing, authentication, etc.
  **userId** | **string**| User Identifier | 

### Return type

 (empty response body)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **DeleteUserAccount**
> DeleteUserAccount(ctx, )
Completely delete a user profile from system

Completely deletes the currently logged in user from the system.

### Required Parameters
This endpoint does not need any parameter.

### Return type

 (empty response body)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ForgotPassword**
> ForgotPassword(ctx, body)
Initiate password reset sequence for a user

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for logging, tracing, authentication, etc.
  **body** | [**ForgotPasswordRequest**](ForgotPasswordRequest.md)| Initiate forgot password sequrence | 

### Return type

 (empty response body)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **GetUser**
> User GetUser(ctx, userId)
Get a specific user

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for logging, tracing, authentication, etc.
  **userId** | **string**| User Identifier | 

### Return type

[**User**](User.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **GetUserAccount**
> map[string][]struct{} GetUserAccount(ctx, )
Get account information for the user

Obtain the current user's account information.

### Required Parameters
This endpoint does not need any parameter.

### Return type

[**map[string][]struct{}**](UserAccountMap.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **GetUsers**
> []User GetUsers(ctx, optional)
Get all users

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for logging, tracing, authentication, etc.
 **optional** | **map[string]interface{}** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a map[string]interface{}.

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **groupId** | **string**| Only retrieve users in the specified group. | 
 **sort** | **string**| This specifies the property (&#x60;user_id&#x60; only, for now) and order (ascending or descending) with which to sort the users. By default, users are sorted by &#x60;user_id&#x60; in ascending order. The syntax is \&quot;&lt;property&gt;:[asc|desc]\&quot; (e.g. \&quot;user_id:desc\&quot;) or just \&quot;&lt;property&gt;\&quot; (ascending order by default).  | 
 **start** | **string**| If provided, this must be a value of the property specified in &#x60;sort&#x60;. Returned users will begin just above or just below this value (for asc/desc order resp.).  | 
 **limit** | **int32**| Maximum number of users to return. If not provided, the limit is 100. | 
 **offset** | **int32**| Number of users past &#x60;start&#x60; to skip. | 

### Return type

[**[]User**](User.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **InviteUser**
> User InviteUser(ctx, body)
Invite a user

Invite an existing user or new user to join an existing account. Only user email is required for invite API 

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for logging, tracing, authentication, etc.
  **body** | [**UserRequest**](UserRequest.md)| Name of user | 

### Return type

[**User**](User.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ProcessInvitations**
> ProcessInvitations(ctx, body)
Process a user's pending account invitations

Process a user's pending invitations. It does both accepts and rejects.

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for logging, tracing, authentication, etc.
  **body** | [**ProcessInviteRequest**](ProcessInviteRequest.md)| Process account invitation (both accepts and rejects) | 

### Return type

 (empty response body)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ResendConfirmEmail**
> ResendConfirmEmail(ctx, userId)
Resend email with link to confirm user's email address

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for logging, tracing, authentication, etc.
  **userId** | **string**| User Identifier | 

### Return type

 (empty response body)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ResendInvitation**
> ResendInvitation(ctx, userId)
Resend invite to the user to join a specific account

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for logging, tracing, authentication, etc.
  **userId** | **string**| User Identifier | 

### Return type

 (empty response body)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ResetPassword**
> ResetPassword(ctx, userId, body)
Reset a user's password

Resetting a user's password. User must have a valid reset token from forgot password step.

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for logging, tracing, authentication, etc.
  **userId** | **string**| User Identifier | 
  **body** | [**PasswordResetRequest**](PasswordResetRequest.md)| Reset password | 

### Return type

 (empty response body)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **UpdateUser**
> User UpdateUser(ctx, userId, body)
Update user

Change a user's properties.

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for logging, tracing, authentication, etc.
  **userId** | **string**| User Identifier | 
  **body** | [**UserRequest**](UserRequest.md)| Name of user | 

### Return type

[**User**](User.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **ValidatePasswordResetToken**
> ValidateTokenResponse ValidatePasswordResetToken(ctx, userId, body)
Validates password reset token for the user

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for logging, tracing, authentication, etc.
  **userId** | **string**| User Identifier | 
  **body** | [**ValidateTokenRequest**](ValidateTokenRequest.md)| Validate token | 

### Return type

[**ValidateTokenResponse**](ValidateTokenResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

