/*
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * API version: 1.0.0-20181211
 * Contact: support@fortanix.com
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */

package sdkms



type App struct {
	// Name of the application. Application names must be unique within an account.
	Name string `json:"name"`

	// Application ID uniquely identifying this application.
	AppId string `json:"app_id"`

	AuthType *AppAuthType `json:"auth_type"`

	// Description of this application.
	Description string `json:"description,omitempty"`

	// Interface used with this application (PKCS11, CNG, JCE, KMIP, etc.).
	Interface_ string `json:"interface,omitempty"`

	// The account ID of the account that this application belongs to.
	AcctId string `json:"acct_id"`

	// An array of Security Group IDs. The application belongs to each Security Group in this array.
	Groups []string `json:"groups"`

	// The default group of this application. This is the group where security objects will be created by default by this application.
	DefaultGroup string `json:"default_group"`

	// Whether this application is enabled.
	Enabled bool `json:"enabled"`

	// The user-defined type of this application.
	AppType string `json:"app_type"`

	Creator *CreatorType `json:"creator"`

	// When this application was created.
	CreatedAt string `json:"created_at"`

	// When this application was last used.
	LastusedAt string `json:"lastused_at,omitempty"`
}


