/*
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * API version: 1.0.0-20181211
 * Contact: support@fortanix.com
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */

package sdkms



type AppRequest struct {
	// Name of this application. Application names must be unique within an account.
	Name string `json:"name"`

	// Description of this application.
	Description string `json:"description,omitempty"`

	// An array of Security Group IDs to add to this application.
	AddGroups []string `json:"add_groups"`

	// An array of security group IDs to remove from this application.
	DelGroups []string `json:"del_groups,omitempty"`

	// The default group of this application. This is the group where security objects will be created by default by this application.
	DefaultGroup string `json:"default_group"`

	// Whether this application is enabled
	Enabled bool `json:"enabled,omitempty"`

	// The user-defined type of this application.
	AppType string `json:"app_type,omitempty"`

	Credential *AppCredential `json:"credential,omitempty"`

	// Size in bytes of app's secret.
	SecretSize int32 `json:"secret_size,omitempty"`
}


