/*
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * API version: 1.0.0-20181211
 * Contact: support@fortanix.com
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */

package sdkms


// Mode and iv are required fields for symmetric key algorithms and ad and tag are required fields for GCM or CCM modes.
type DecryptRequestEx struct {
	Key *SobjectDescriptor `json:"key"`

	Alg *ObjectType `json:"alg,omitempty"`

	// The ciphertext to decrypt.
	Cipher string `json:"cipher"`

	Mode *CryptMode `json:"mode,omitempty"`

	// The initialization value used to encrypt this ciphertext. This field is required for symmetric ciphers, and ignored for asymmetric ciphers. 
	Iv string `json:"iv,omitempty"`

	// The authenticated data used with this ciphertext and authentication tag. This field is required for symmetric ciphers using cipher mode GCM or CCM, and must not be specified for all other ciphers. 
	Ad string `json:"ad,omitempty"`

	// The authentication tag used with this ciphertext and authenticated data. This field is required for symmetric ciphers using cipher mode GCM or CCM, and must not be specified for all other ciphers. 
	Tag string `json:"tag,omitempty"`
}


