/*
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * API version: 1.0.0-20181211
 * Contact: support@fortanix.com
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */

package sdkms


// A request to encrypt data using a symmetric or asymmetric key.
type EncryptRequestEx struct {
	Key *SobjectDescriptor `json:"key"`

	Alg *ObjectType `json:"alg"`

	// The plaintext to encrypt.
	Plain string `json:"plain"`

	Mode *CryptMode `json:"mode,omitempty"`

	// For symmetric ciphers, this value will be used for the cipher initialization value. If not provided, SDKMS will generate a random iv and return it in the response. If provided, iv length must match the length required by the cipher and mode. 
	Iv string `json:"iv,omitempty"`

	// For symmetric ciphers with cipher mode GCM or CCM, this optionally specifies the authenticated data used by the cipher. This field must not be provided with other cipher modes. 
	Ad string `json:"ad,omitempty"`

	// For symmetric ciphers with cipher mode GCM or CCM, this field specifies the length of the authentication tag to be produced. This field is specified in bits (not bytes). This field is required for symmetric ciphers with cipher mode GCM or CCM. It must not be specified for asymmetric ciphers and symmetric ciphers with other cipher modes.
	TagLen int32 `json:"tag_len,omitempty"`
}


