/*
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * API version: 1.0.0-20181211
 * Contact: support@fortanix.com
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */

package sdkms



type PersistTransientKeyRequest struct {
	// Name of the persisted security object. Security object names must be unique within an account.
	Name string `json:"name"`

	// Description of the persisted security object.
	Description string `json:"description,omitempty"`

	// User-defined metadata for the persisted key. Stored as key-value pairs.
	CustomMetadata map[string]string `json:"custom_metadata,omitempty"`

	// Whether the new security object should be enabled. Disabled security objects may not perform cryptographic operations. 
	Enabled bool `json:"enabled,omitempty"`

	// Optional array of key operations to be enabled for this security object. If this property is not provided, the SDKMS server will provide a default set of key operations. Note that if you provide an empty array, all key operations will be disabled. 
	KeyOps []KeyOperations `json:"key_ops,omitempty"`

	// Group ID (not name) of the security group that the persisted security object should belong to. The user or application creating this security object must be a member of this group. If no group is specified, the default group for the user or application will be used. 
	GroupId string `json:"group_id,omitempty"`

	// Transient key blob.
	TransientKey string `json:"transient_key"`
}


