/*
 * Fortanix SDKMS REST API
 *
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * API version: 1.0.0-20181211
 * Contact: support@fortanix.com
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */

package sdkms



type UserRequest struct {
	// User's email address.
	UserEmail string `json:"user_email"`

	// The password to assign to this user in SDKMS.
	UserPassword string `json:"user_password"`

	AccountRole []UserAccountFlags `json:"account_role,omitempty"`

	// The user will be added to the specified security groups with the specified roles.
	AddGroups map[string]UserGroupFlags `json:"add_groups,omitempty"`

	// The user will be removed from the specified security groups.
	DelGroups map[string]UserGroupFlags `json:"del_groups,omitempty"`

	// The user's role in the specified groups will be updated to the specified roles.
	ModGroups map[string]UserGroupFlags `json:"mod_groups,omitempty"`

	// Whether this application is enabled.
	Enabled bool `json:"enabled,omitempty"`

	AddU2fDevices []U2fAddDeviceRequest `json:"add_u2f_devices,omitempty"`

	DelU2fDevices []U2fDelDeviceRequest `json:"del_u2f_devices,omitempty"`

	RenameU2fDevices []U2fRenameDeviceRequest `json:"rename_u2f_devices,omitempty"`
}


